The IPv6 Compact Routing Header (CRH)
Ron Bonica
Juniper Networks
2251 Corporate Park Drive
Herndon
20171
Virginia
USA
rbonica@juniper.net
Yuji Kamite
NTT Communications Corporation
3-4-1 Shibaura, Minato-ku
Tokyo
108-8118
Japan
y.kamite@ntt.com
Andrew Alston
Liquid Telecom
Nairobi
Kenya
Andrew.Alston@liquidtelecom.com
Daniam Henriques
Liquid Telecom
Johannesburg
South Africa
daniam.henriques@liquidtelecom.com
Luay Jalil
Verizon
Richardson
Texas
USA
luay.jalil@one.verizon.com
30 May 2024
INT Area
6man
IPv6
Routing header
This document describes an experiment in which two new IPv6 Routing headers are implemented and deployed. Collectively, they are called the Compact Routing Headers (CRH). Individually, they are called CRH-16 and CRH-32.
One purpose of this experiment is to demonstrate that the CRH can be implemented and deployed in a production network. Another purpose is to demonstrate that the security considerations, described in this document, can be addressed with access control lists. Finally, this document encourages replication of the experiment.

Introduction
IPv6 source nodes use Routing headers to specify the path that a packet takes to its destination(s). The IETF has defined several Routing types. This document defines two new Routing types. Collectively, they are called the Compact Routing Headers (CRH). Individually, they are called CRH-16 and CRH-32.
The CRH allows IPv6 source nodes to specify the path that a packet takes to its destination. The CRH can be encoded in relatively few bytes. The following are reasons for encoding the CRH in as few bytes as possible:
- Many ASIC-based forwarders copy headers from buffer memory to on-chip memory. As header sizes increase, so does the cost of this copy.
- Because Path MTU Discovery (PMTUD) is not entirely reliable, many IPv6 hosts refrain from sending packets larger than the IPv6 minimum link MTU (i.e., 1280 bytes). When packets are small, the overhead imposed by large Routing Headers is excessive.
This document describes an experiment whose purposes are:
- To demonstrate that the CRH can be implemented and deployed.
- To demonstrate that the security considerations, described in this document, can be addressed with access control lists.
- To encourage replication of the experiment.

Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC8174] when, and only when, they appear in all capitals, as shown here.

The Compact Routing Headers (CRH)
Both CRH versions (i.e., CRH-16 and CRH-32) contain the following fields:
- Next Header - Defined in [RFC8200].
- Hdr Ext Len - Defined in [RFC8200].
- Routing Type - Defined in [RFC8200]. (CRH-16 value is 5. CRH-32 value is 6).
- Segments Left - Defined in [RFC8200].
- Type-specific Data - Described in [RFC8200].
In the CRH, the Type-specific data field contains a list of CRH Segment Identifiers (CRH SIDs). Each CRH SID identifies an entry in the CRH Forwarding Information Base (CRH-FIB) . Each CRH-FIB entry identifies an interface on the path that the packet takes to its destination.
CRH SIDs are listed in reverse order. So, the first CRH SID in the list represents the final interface in the path. Because CRH SIDs are listed in reverse order, the Segments Left field can be used as an index into the CRH SID list. In this document, the "current CRH SID" is the CRH SID list entry referenced by the Segments Left field.
The first CRH SID in the path is omitted from the list unless there is some reason to preserve it. See Appendix A for an example.
In the CRH-16, each CRH SID is encoded in 16-bits. In the CRH-32, each CRH SID is encoded in 32-bits.
In all cases, the CRH MUST end on a 64-bit boundary. So, the Type- specific data field MUST be padded with zeros if the CRH would otherwise not end on a 64-bit boundary.

CRH-16
   0                   1                   2                   3
   0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
  |  Next Header  |  Hdr Ext Len  | Routing Type  | Segments Left |
  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
  |             SID[0]            |          SID[1]               |
  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-|
  |                          .........
  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-

CRH-32
   0                   1                   2                   3
   0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
  |  Next Header  |  Hdr Ext Len  | Routing Type  | Segments Left |
  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
  +                             SID[0]                            +
  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
  +                             SID[1]                            +
  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
  |                          .........
  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-

The CRH Forwarding Information Base (CRH-FIB)
Each CRH SID identifies a CRH-FIB entry.
Each CRH-FIB entry contains:
- An IPv6 address.
- A topological function.
- Arguments for the topological function. (Optional).
The IPv6 address can be a Global Unicast Address (GUA), a Link Local Unicast address (LLU), or a Unique Local Address (ULA). When the IPv6 address is the final address in a path, it can also be a multicast address.
The topological function specifies how the processing node forwards the packet to the interface identified by the IPv6 address. The following are examples:
- Forward the packet through the least-cost path to the interface identified by the IPv6 address (i.e., loose source routing).
- Forward the packet through a specified interface to the interface identified by the IPv6 address (i.e.,strict source routing)
Some topological functions require parameters. For example, a topological function might require a parameter that identifies the interface through which the packet is forwarded.
The CRH-FIB can be populated:
- By an operator, using a Command Line Interface (CLI).
- By a controller, using the Path Computation Element (PCE) Communication Protocol (PCEP) or the Network Configuration Protocol (NETCONF).
- By a distributed routing protocol [ISO10589-Second-Edition], [RFC5340], [RFC4271].
The above-mentioned mechanisms are not defined here and are beyond the scope of this document

Processing Rules
The following rules describe CRH processing:
- If Hdr Ext Len indicates that the CRH is larger than the implementation can process, discard the packet and send an ICMPv6 Parameter Problem, Code 0, message to the Source Address, pointing to the Hdr Ext Len field.
- Compute L, the minimum CRH length ( Section 5.1).
- If L is greater than Hdr Ext Len, discard the packet and send an ICMPv6 Parameter Problem, Code 6, message to the Source Address, pointing to the Segments Left field.
- Decrement Segments Left.
- Search for the current CRH SID in the CRH-FIB. In this document, the "current CRH SID" is the CRH SID list entry referenced by the Segments Left field.
- If the search does not return a CRH-FIB entry, discard the packet and send an ICMPv6 Parameter Problem, Code 0, message to the Source Address, pointing to the current SID.
- If Segments Left is greater than 0 and the CRH-FIB entry contains a multicast address, discard the packet and send an ICMPv6 Parameter Problem, Code 0, message to the Source Address, pointing to the current SID. (This prevents packet storms.)
- Copy the IPv6 address from the CRH-FIB entry to the Destination Address field in the IPv6 header.
- Submit the packet, its topological function and its parameters to the IPv6 module. See NOTE.
NOTE: By default, the IPv6 module determines the next-hop and forwards the packet. However, the topological function may elicit another behavior. For example, the IPv6 module may forward the packet through a specified interface.

Computing Minimum CRH Length
The algorithm described in this section accepts the following CRH fields as its input parameters:
- Routing Type (i.e., CRH-16 or CRH-32).
- Segments Left.
It yields L, the minimum CRH length. The minimum CRH length is measured in 8-octet units, not including the first 8 octets.
<CODE BEGINS>

switch(Routing Type) {
    case CRH-16:
        if (Segments Left <= 2)
            return(0)
        sidsBeyondFirstWord = Segments Left - 2;
        sidPerWord = 4;
    case CRH-32:
        if (Segments Left <= 1)
            return(0)
        sidsBeyondFirstWord = Segments Left - 1;
        sidsPerWord = 2;
    case default:
        return(0xFF);
    }

words = sidsBeyondFirstWord div sidsPerWord;
if (sidsBeyondFirstWord mod sidsPerWord)
    words++;

return(words)

<CODE ENDS>

Mutability
In the CRH, the Segments Left field is mutable. All remaining fields are immutable.

Applications And SIDs
A CRH contains one or more CRH SIDs. Each CRH SID is processed by exactly one CRH-configured router whose one address matches the packet destination address.
Therefore, a CRH SID is not required to have domain-wide significance. Applications can:
- Allocate CRH SIDs so that they have domain-wide significance.
- Allocate CRH SIDs so that they have node-local significance.

Operational Considerations
PING and TRACEROUTE both operate correctly in the presence of the CRH. TCPDUMP and Wireshark have been extended to support the CRH.
PING and TRACEROUTE report 16-bit CRH SIDs for CRH-16, and 32-bit CRH SIDs for CRH-32. It is recommended that the experimental versions of PING use the text representations described in Section 9.

Textual Representation
A 16-bit CRH SID can be represented by four lower-case hexadecimal digits. Leading zeros SHOULD be omitted. However, the all-zeros CRH SID MUST be represented by a single 0. The following are examples:
- beef
- eef
- 0
A 16-bit CRH SID also can be represented in dotted-decimal notation. The following are examples:
- 192.0
- 192.51
A 32-bit CRH SID can be represented by four lower-case hexadecimal digits, a colon (:), and another four lower-case hexadecimal digits. Leading zeros MUST be omitted. The following are examples:
- dead:beef
- ead:eef
- :beef
- beef:
:
A 32-bit CRH SID can also be represent in dotted-decimal notation. The following are examples:
- 192.0.2.1
- 192.0.2.2
- 192.0.2.3

Security Considerations
In this document, one node trusts another only if both nodes are operated by the same party. A node determines whether it trusts another node by examining its IP address. In many networks, operators number their nodes from a small number of prefixes. This facilitates identification of trusted nodes.
A node can encounter security vulnerabilities when it processes a Routing Header that originated on an untrusted node [RFC5095]. Therefore, nodes MUST deploy ACLs that discard packets containing the CRH when both of the following conditions are true:
- The Source Address does not identify an interface on a trusted node.
- The Destination Address identifies an interface on the local node.
The above-mentioned ACLs do not protect the node from attack packets that contain a forged (i.e., spoofed) Source Address. In order to mitigate this risk, nodes MAY also discard packets containing the CRH when all of the following conditions are true:
- The Source Address identifies an interface on a trusted node.
- The Destination Address identifies an interface on the local node.
- The packet does not pass an Enhanced Feasible-Path Unicast Reverse Path Forwarding (RPF) ,
The RPF check eliminates some, but not all packets with forged source addresses. Therefore, a network operator that deploys CRH MUST implement Access Control Lists (ACL) on each of its edge nodes. The ACL discards packets whose source address identifies an interface on a trusted node.
The CRH is compatible with end-to-end IPv6 Authentication Header (AH) [RFC4302] processing. This is becasue the source node calculates the Integrity Check Value (ICV) over the packet as it arrives at the destination node.

Implementation and Deployment Status
Juniper Networks has produced experimental implementations of the CRH on the MX-series (ASIC-based) router
Liquid Telecom has produced experimental implementations of the CRH on software based routers.
The CRH has carried non-production traffic in CERNET and Liquid Telecom.
Interoperability among these implementations has not yet been demonstrated.

Experimental Results
Parties participating in this experiment should publish experimental results within one year of the publication of this document. Experimental results should address the following:
- Effort required to deploy
  - Was deployment incremental or network-wide?
  - Was there a need to synchronize configurations at each node or could nodes be configured independently
  - Did the deployment require hardware upgrade?
  - Did the CRH SIDs have domain-wide or node-local significance?
- Effort required to secure
- Performance impact
- Effectiveness of risk mitigation with ACLs
- Cost of risk mitigation with ACLs
- Mechanism used to populate the FIB
- Scale of deployment
- Interoperability
  - Did you deploy two inter-operable implementations?
  - Did you experience interoperability problems?
  - Did implementations generally implement the same topological functions with identical arguments?
  - Were topological function semantics identical on each implementation?
- Effectiveness and sufficiency of OAM mechanism
  - Did PING work?
  - Did TRACEROUTE work?
  - Did Wireshark work?
  - Did TCPDUMP work?

IANA Considerations
This document makes the following registrations in the "Internet Protocol Version 6 (IPv6) Parameters" "Routing Types" subregistry maintained by IANA:
         +-------+------------------------------+---------------+
         | Value | Description                  | Reference     |
         +=======+==============================+===============+
         | 5     | CRH-16                       | This document |
         +-------+------------------------------+---------------+
         | 6     | CRH-32                       | This document |
         +-------+------------------------------+---------------+

Acknowledgements
Thanks to Dr. Vanessa Ameen, Dale Carder, Brian Carpenter, Adrian Farrel, Fernando Gont, Naveen Kottapalli, Joel Halpern, Mark Smith, Reji Thomas, Tony Li, Xing Li, Gerald Schmidt, Nancy Shaw, Ketan Talaulikar, and Chandra Venkatraman for their contributions to this document.

Contributors
Gang Chen
Baidu
No.10 Xibeiwang East Road Haidian District
Beijing 100193 P.R. China
Email: phdgang@gmail.com
Yifeng Zhou
ByteDance
Building 1, AVIC Plaza, 43 N 3rd Ring W Rd Haidian District
Beijing 100000 P.R. China
Email: yifeng.zhou@bytedance.com
Gyan Mishra
Verizon
Silver Spring, Maryland, USA
Email: hayabusagsm@gmail.com

Normative References

Informative References
[IANA-RH]

Routing Headers
IANA
[ISO10589-Second-Edition]

"Intermediate system to Intermediate system intra-domain routeing information exchange protocol for use in conjunction with the protocol for providing the connectionless-mode Network Service (ISO 8473)", ISO/IEC 10589:2002, Second Edition,
International Organization for Standardization
November 2001
[RFC8174]
[RFC8200]
[RFC5340]
[RFC4271]
[RFC5095]
[RFC4302]

CRH Processing Examples
This appendix demonstrates CRH processing in the following scenarios:
- The CRH SID list contains one entry for each segment in the path .
- The CRH SID list omits the first entry in the path .

Reference Topology

 -----------                 -----------                 -----------
|Node: S    |               |Node: I1   |               |Node: I2   |
|Loopback:  |---------------|Loopback:  |---------------|Loopback:  |
|2001:db8::a|               |2001:db8::1|               |2001:db8::2|
 -----------                 -----------                 -----------
      |                                                       |
      |                      -----------                      |
      |                     |Node: D    |                     |
       ---------------------|Loopback:  |---------------------
                            |2001:db8::b|
                             -----------

Figure 3 provides a reference topology that is used in all examples.

Node SIDs
SID | IPv6 Address | Forwarding Method
2 | 2001:db8::2 | Least-cost path
11 | 2001:db8::b | Least-cost path
Table 1 describes two entries that appear in each node's CRH-FIB.

The CRH SID List Contains One Entry For Each Segment In The Path
In this example, Node S sends a packet to Node D, via I2. In this example, I2 appears in the CRH segment list.
As the packet travels from S to I2: |
Source Address = 2001:db8::a | Segments Left = 1
Destination Address = 2001:db8::2 | SID[0] = 11
| SID[1] = 2
As the packet travels from I2 to D: |
Source Address = 2001:db8::a | Segments Left = 0
Destination Address = 2001:db8::b | SID[0] = 11
| SID[1] = 2

The CRH SID List Omits The First Entry In The Path
In this example, Node S sends a packet to Node D, via I2. In this example, I2 does not appear in the CRH segment list.
As the packet travels from S to I2: |
Source Address = 2001:db8::a | Segments Left = 1
Destination Address = 2001:db8::2 | SID[0] = 11
As the packet travels from I2 to D: |
Source Address = 2001:db8::a | Segments Left = 0
Destination Address = 2001:db8::b | SID[0] = 11